unit testmmain;

{
TMagRas test large number of connections
========================================

Allows hundreds of connections to be created and deleted,
so that application handling of such large numbers can
be tested

Created by Angus Robertson, Magenta Systems Ltd, England
in 2002, delphi@magsys.co.uk, http://www.magsys.co.uk/delphi/
Last updated: 18th July 2002

}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, magrasedt, magrascon, MagRasEnt, Spin;

type
  TForm1 = class(TForm)
    MagRasCon: TMagRasCon;
    MagRasEdt: TMagRasEdt;
    Entries: TListBox;
    doCreate: TButton;
    doDelete: TButton;
    doShowEntries: TButton;
    NameMask: TEdit;
    NumLow: TSpinEdit;
    NumHigh: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    doExit: TButton;
    LabelTot: TLabel;
    Label4: TLabel;
    LabelProgress: TLabel;
    Device: TComboBox;
    procedure doExitClick(Sender: TObject);
    procedure doShowEntriesClick(Sender: TObject);
    procedure doCreateClick(Sender: TObject);
    procedure doDeleteClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.doExitClick(Sender: TObject);
begin
    Close ;
end;

procedure TForm1.doShowEntriesClick(Sender: TObject);
var
    I, ret: integer ;
begin
    Entries.Items.Clear ;
    ret := MagRasGetEntryList ('') ;
    if (ret <> 0) then exit ;
    if (MagRasNumEntryRec = 0) then exit ;
    LabelTot.Caption := 'Total Entries: ' + IntToStr (MagRasNumEntryRec) ;
    for I := 0 to Pred (MagRasNumEntryRec) do
            Entries.Items.Add (MagRasEntryRecs [I].EntryName) ;
end;

procedure TForm1.doCreateClick(Sender: TObject);
var
    I, J, ret: integer ;
    newname: string ;
begin
    if Pos ('#', NameMask.Text) <= 0 then exit ;
    if NumLow.Value > NumHigh.Value then exit ;
    J := 0 ;
    for I := NumLow.Value to NumHigh.Value do
    begin
        newname := StringReplace (NameMask.Text, '#', IntToStr (I), []) ;
        LabelProgress.Caption := 'Creating Entry: ' + newname ;
        Application.ProcessMessages ;
        MagRasEdt.PPPDefault ;

    // silly telephone number
        MagRasEdt.LocalPhoneNumber := '1111' + IntToStr (I) ;

	// device stuff - required, must match precisely name and type from lists
    	MagRasEdt.DeviceName := MagRasCon.DeviceNameList [Device.ItemIndex] ;
    	MagRasEdt.DeviceType := MagRasCon.DeviceTypeList [Device.ItemIndex] ;

    // create new entry
        ret := MagRasEdt.PutAllEntryProps (newname) ;
        if ret <> 0 then
        begin
            LabelProgress.Caption := MagRasEdt.StatusStr ;
            exit ;
        end ;
        inc (J) ;
    end ;
    LabelProgress.Caption := 'Created New Entries OK, Total ' + IntToStr (J) ;
    doShowEntriesClick (self) ;
end;

procedure TForm1.doDeleteClick(Sender: TObject);
var
    I, J, ret: integer ;
begin
    if Entries.Items.Count = 0 then exit ;
    J := 0 ;
    for I := 0 to Pred (Entries.Items.Count) do
    begin
        if Entries.Selected [I] then
        begin
            LabelProgress.Caption := 'Deleting Entry: ' + Entries.Items [I] ;
            Application.ProcessMessages ;
            MagRasCon.EntryName := Entries.Items [I] ;
            ret := MagRasCon.DeletePhonebook ;
            if ret <> 0 then
            begin
                LabelProgress.Caption := MagRasCon.StatusStr ;
                exit ;
            end ;
            inc (J) ;
        end ;
    end ;
    LabelProgress.Caption := 'Deleted Entries OK, Total ' + IntToStr (J) ;
    doShowEntriesClick (self) ;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
    I: integer ;
begin
// see if RAS has been installed
	if MagRasCon.TestRAS then
    begin

	// get list of RAS capable modems and devices - don't sort list!
    	MagRasCon.GetDeviceList ;
        if MagRasCon.DeviceNameList.Count <> 0 then
        begin
        	for I := 0 to MagRasCon.DeviceNameList.Count - 1 do
            begin
            	Device.Items.Add (MagRasCon.DeviceNameList [I] +
	                ' (' + LowerCase (MagRasCon.DeviceTypeList [I]) + ')') ;
			end ;
            Device.ItemIndex := 0 ;
		end ;
	end
    else
    begin
	 	LabelProgress.Caption := 'RAS is not installed' ;
        beep ;
    end
end;

end.
